// SDL template by g.c.
// win32: g++ sdl_template.cpp -Wall -pedantic -lSDL -lopengl32 -lglu32
// linux: g++ sdl_template.cpp -Wall -pedantic -lSDL -lGL -lGLU

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <gl/gl.h>
#include <gl/glu.h>
#include <SDL/sdl.h>
#ifdef _WIN32
 #include <windows.h>
#endif
#include <stdint.h>
#include <math.h>

using namespace std;

// SDL sugz
#undef main
#define MINX -7.7f
#define WIDTH 15.4f
#define MINY -5.75f
#define HEIGHT 11.5f

// globals
static int screen_width;
static int screen_height;
bool keys[SDLK_LAST];
uint32_t last_tick;
float ratio;

#define COW_SPEED (0.8f)
#define PIG_SPEED (1.6f)


#define PW 15
#define PH 11

int plansza[PH][PW] =
{
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0 },
  { 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0 },
  { 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0 },
  { 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0 },
  { 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0 },
  { 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0 },
  { 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};

int travel_map[PH][PW] =
{
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,15, 0 },
  { 0,30,29,28,27, 0, 0, 0, 0, 0, 0, 0, 0,16, 0 },
  { 0,31, 0, 0,26,25,24,23,22,21,20,19,18,17, 0 },
  { 0,32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0,33, 0, 0, 0, 0, 0,47,48,49,50, 0, 0, 0, 0 },
  { 0,34, 0,40,41,42, 0,46, 0, 0,51, 0, 0, 0, 0 },
  { 0,35, 0,39, 0,43,44,45, 0, 0,52, 0, 0, 0, 0 },
  { 0,36,37,38, 0, 0, 0, 0, 0, 0,53,54,55,56,57 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};

int travel_map_last = 57;

float travel_x[60];
float travel_y[60];




#define MAP_START_X (MINX + 0.30f)
#define MAP_START_Y (MINY + 0.33f)

float enemy_start_x = MAP_START_X + 0.50f;
float enemy_start_y = MAP_START_Y + 0.50f + 1.0f;

class enemy
{
  public:
    float x;
    float y;
    float dest_x;
    float dest_y;
    int current_dest;
    bool done;


    int type; // 0 cow, 1 pig
    float hp; // 100 is max


};

enemy enemies[100];

uint32_t last_enemy_add_time;
int enemy_count;

int money;
int life;

bool game_end;

int cursor_x, cursor_y;

unsigned int textures[100];

#define TEX_LIFE 0
#define TEX_COIN_SILV 1
#define TEX_COIN_GOLD 2

#define TEX_GRASS 3
#define TEX_ROAD 4
#define TEX_START 5
#define TEX_END 6

#define TEX_COW 7
#define TEX_PIG 8
#define TEX_CAN1 9
#define TEX_CAN2 10
#define TEX_CAN3 11

#define TEX_GAMEEND 12

unsigned int can_tex[4] = 
{
  0, TEX_CAN1, TEX_CAN2, TEX_CAN3
};

float colors[][3] =
{
  { 0.0f, 0.5f, 0.1f },
  { 0.3f, 0.3f, 0.3f },
  { 0.0f, 1.0f, 0.3f },
  { 1.0f, 0.3f, 0.3f }
};

class turret
{
  public:
    float fx, fy;
    int x, y;
    int level;
    unsigned int last_shot;
    unsigned int start_shot;
    enemy *target;
    
};

float turret_power[] = 
{ 0.0f, 5.0f, 10.0f, 20.0f };

float turret_range[] = 
{ 0, 1.5, 2.5, 3 };

turret turrets[15*11];

int turret_placed;


// func
static bool initSDL(bool fullscreen = false, int width = 640, int height = 480);
static bool initOpenGL();
static void scene();
static bool events();
static unsigned int make_texture(const char* file_name, bool transp);

float dmg_ratio = 1.0f;



// main
int 
main(int argc, char **argv, char **envp)
{
  if(!initSDL())    return 1;
  if(!initOpenGL()) return 2;

  textures[TEX_LIFE] = make_texture("gfx/life.bmp", true); 
  textures[TEX_COIN_SILV] = make_texture("gfx/coinsilv.bmp", true); 
  textures[TEX_COIN_GOLD] = make_texture("gfx/coin.bmp", true);
  textures[TEX_GRASS] = make_texture("gfx/grass.bmp", true);
  textures[TEX_ROAD] = make_texture("gfx/road.bmp", true);
  textures[TEX_START] = make_texture("gfx/road_s.bmp", true);
  textures[TEX_END] = make_texture("gfx/road_e.bmp", true);

  textures[TEX_COW] = make_texture("gfx/cow.bmp", true);
  textures[TEX_PIG] = make_texture("gfx/pig.bmp", true);

  textures[TEX_CAN1] = make_texture("gfx/can1.bmp", true);
  textures[TEX_CAN2] = make_texture("gfx/can2.bmp", true);
  textures[TEX_CAN3] = make_texture("gfx/can3.bmp", true);

  textures[TEX_GAMEEND] = make_texture("gfx/the_end.bmp", true);

  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 



  // precalc travel map
  int i, j;
  for(j = 0; j < PH; j++)
  {
    for(i = 0; i < PW; i++)
    {
      if(travel_map[j][i] > 0)
      {
        int pos = travel_map[j][i]; // start with [1]
        travel_x[pos] = MAP_START_X + 0.50f + (float)i;
        travel_y[pos] = MAP_START_Y + 0.50f + (float)j;

        //printf("found [%i] at %f, %f\n", pos, travel_x[pos], travel_y[pos]);

      }
    }
  }

  ratio = 0.0;
  last_tick = 0xffffffff;

  money = 34;
  life = 20;


  while(1)
  {
    uint32_t now_tick = SDL_GetTicks();
    if(last_tick != 0xffffffff);
      ratio = (float)(now_tick - last_tick) / 1000.0f;
    last_tick = now_tick;


    if(!events())
      break;

    scene();
  }

  SDL_Quit();

  return 0;
}

void
draw_quad(float x, float y, float w, float h, float r, float g, float b)
{
  //printf("%f %f, %f %f,  %f %f %f\n", x,y,w,h,r,g,b);

  glBegin(GL_QUADS);
  glTexCoord2f(0.0f + 0.001f, 0.0f + 0.001f); glColor3f(r, g, b); glVertex2f(x + 0, y + 0);
  glTexCoord2f(1.0f - 0.001f, 0.0f + 0.001f); glColor3f(r, g, b); glVertex2f(x + w, y + 0);
  glTexCoord2f(1.0f - 0.001f, 1.0f - 0.001f); glColor3f(r, g, b); glVertex2f(x + w, y + h);
  glTexCoord2f(0.0f + 0.001f, 1.0f - 0.001f); glColor3f(r, g, b); glVertex2f(x + 0, y + h);
  glEnd();

}


void
draw_quada(float x, float y, float w, float h, float r, float g, float b,float a)
{
  //printf("%f %f, %f %f,  %f %f %f\n", x,y,w,h,r,g,b);

  glBegin(GL_QUADS);
  glTexCoord2f(0.0f + 0.001f, 0.0f + 0.001f); glColor4f(r, g, b,a); glVertex2f(x + 0, y + 0);
  glTexCoord2f(1.0f - 0.001f, 0.0f + 0.001f); glColor4f(r, g, b,a); glVertex2f(x + w, y + 0);
  glTexCoord2f(1.0f - 0.001f, 1.0f - 0.001f); glColor4f(r, g, b,a); glVertex2f(x + w, y + h);
  glTexCoord2f(0.0f + 0.001f, 1.0f - 0.001f); glColor4f(r, g, b,a); glVertex2f(x + 0, y + h);
  glEnd();

}

void
draw_line_quad(float x, float y, float w, float h, float r, float g, float b)
{
  //printf("%f %f, %f %f,  %f %f %f\n", x,y,w,h,r,g,b);

  glBegin(GL_LINE_STRIP);
  glColor3f(r, g, b); glVertex2f(x + 0, y + 0);
  glColor3f(r, g, b); glVertex2f(x + w, y + 0);
  glColor3f(r, g, b); glVertex2f(x + w, y + h);
  glColor3f(r, g, b); glVertex2f(x + 0, y + h);
  glColor3f(r, g, b); glVertex2f(x + 0, y + 0);
  glEnd();

}

// scene
void
static scene()
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glTranslatef(0.0f, 0.5f, -13.0f);
  glScalef(1.0f, -1.0f, 1.0f);

  // draw sth here
  // -- EXAMPLE --
  static float rot;
  glPushMatrix();
  {
    int i, j;


          glEnable(GL_TEXTURE_2D);

    for(i = 0; i < PW; i++)
    {
      for(j = 0; j < PH; j++)
      {
        int k = plansza[j][i];
        switch(k)
        {
          case 0:
           glBindTexture(GL_TEXTURE_2D, textures[TEX_GRASS]);
           break;

          case 1:
           glBindTexture(GL_TEXTURE_2D, textures[TEX_ROAD]);
           break;

          case 2:
           glBindTexture(GL_TEXTURE_2D, textures[TEX_END]);
           break;

          case 3:
           glBindTexture(GL_TEXTURE_2D, textures[TEX_START]);
           break;

        }

        if(k == 0)
        {
          glEnable(GL_BLEND);
         draw_quad(
              (float)i + MINX + 0.30f,
              (float)j + MINY + 0.33f - 0.46,
              1.0f, 1.48f, 
              1,1,1
              );
    glDisable(GL_BLEND);

        }
        else
        {

          draw_quad(
              (float)i + MINX + 0.30f,
              (float)j + MINY + 0.33f,
              1.0f, 1.0f, 
              1,1,1
              );
        }
            
      }
    }
    glDisable(GL_TEXTURE_2D);

    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    for(i = 0; i < enemy_count; i++)
    {
      glPushMatrix();
      float cl=1;
      if(enemies[i].hp <= 0.0f)
        cl = 0.4;

      
      if(enemies[i].type == 0)
      {
        glBindTexture(GL_TEXTURE_2D, textures[TEX_COW]);
        draw_quada(enemies[i].x - 0.50f, enemies[i].y - 0.50f, 1.00f, 1.00f, cl,cl,cl,cl);
      }
      else
      {
        glBindTexture(GL_TEXTURE_2D, textures[TEX_PIG]);
        draw_quada(enemies[i].x - 0.50f, enemies[i].y - 0.50f, 1.00f, 1.00f, cl,cl,cl,cl);
      }

      glPopMatrix();
    }
    glDisable(GL_BLEND);
    glDisable(GL_TEXTURE_2D);

    //glDisable(GL_TEXTURE);
    for(i = 0; i < enemy_count; i++)
    {
      if(enemies[i].hp <= 0.0f)
        continue;

      // draw hp bar
      draw_quad(
        enemies[i].x - 0.3f, enemies[i].y - 0.25f + 0.50f,
        0.6f, 0.10f,
        1.0, 0.0, 0.0);

      draw_quad(
        enemies[i].x - 0.3f, enemies[i].y - 0.25f + 0.50f,
        0.6f * (enemies[i].hp / 100.0f), 0.10f,
        0.0, 1.0, 0.0);

    }

    // Draw turrets
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    for(i = 0; i < turret_placed; i++)
    {
      turret *t = &turrets[i];

      glBindTexture(GL_TEXTURE_2D, textures[can_tex[t->level]]);
       draw_quad(
              (float)t->x + MINX + 0.30f,
              (float)t->y + MINY + 0.33f,
              1.0f, 1.0f, 
              1,1,1
              );

    }

    glDisable(GL_BLEND);
    glDisable(GL_TEXTURE_2D);


    // Draw marker
    draw_line_quad(
      MAP_START_X + (float)cursor_x, 
      MAP_START_Y + (float)cursor_y, 
      1.0f, 1.0f,
      0.5f, 1.0f, 0.5f);

    // Draw life
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    glBindTexture(GL_TEXTURE_2D, textures[TEX_LIFE]);
    for(i = 0; i < life; i++)
    {
      draw_quad(
          MINX + (float)i * 0.7, MINY - 1.0f, 
          1.0f, 1.0f,
          1,1,1);


    }
    glDisable(GL_BLEND);
    glDisable(GL_TEXTURE_2D);

    // Draw money
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    if(money > 0)
    {
    glBindTexture(GL_TEXTURE_2D, textures[TEX_COIN_SILV]);
    for(i = 0; i < (money % 10); i++)
    {
      draw_quad(
          MINX + (float)i * 0.5, MINY + HEIGHT + 1, 
          1.0f, 1.0f,
          1,1,1);
    }

    glBindTexture(GL_TEXTURE_2D, textures[TEX_COIN_GOLD]);
    for(i = 0; i < (money / 10); i++)
    {
      draw_quad(
          MINX + (float)i * 0.5, MINY + HEIGHT, 
          1.0f, 1.0f,
          1,1,1);
    }
    }
    glDisable(GL_BLEND);
    glDisable(GL_TEXTURE_2D);

   // Draw turrets lasers
    glLineWidth(5);
    for(i = 0; i < turret_placed; i++)
    {
      turret *t = &turrets[i];
      if(!t->target || t->last_shot + 200 > SDL_GetTicks())
        continue;

      switch(t->level)
      {
        case 1: glColor3f(1,1,1); break;
        case 2: glColor3f(0.5f,0.5f,1); break;
        case 3: glColor3f(1,0.5f,0.5f); break;
      }

      glBegin(GL_LINES);
      glVertex2f(t->fx, t->fy);
      glVertex2f(t->target->x, t->target->y);
      glEnd();



    }
    glLineWidth(1);
 glColor3f(1,1,1);


  if(game_end)
  {
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);

    glBindTexture(GL_TEXTURE_2D, textures[TEX_GAMEEND]);

      draw_quad(
          MINX, MINY, 
          WIDTH, HEIGHT,
          1,1,1);


    glDisable(GL_BLEND);
    glDisable(GL_TEXTURE_2D);
  }

  }
  glPopMatrix();
  // -- EXAMPLE --

  SDL_GL_SwapBuffers(); 
}

turret *get_turret(int x, int y)
{
  int i;
  for(i = 0; i < turret_placed; i++)
  {
    if(turrets[i].x == x && turrets[i].y == y)
    {
      return &turrets[i];  
    }
  }

  return NULL;
}


// events
static bool
events()
{
  SDL_Event ev;
  memset(&ev, 0, sizeof(ev));
  while(SDL_PollEvent(&ev))
  {
    switch( ev.type )
    { 
      case SDL_KEYUP:
	keys[ev.key.keysym.sym] = false;	
	break;
      
      
      case SDL_KEYDOWN:
        if(ev.key.keysym.sym == SDLK_ESCAPE)
          return false;
	keys[ev.key.keysym.sym] = true;
	break;	
	
      case SDL_QUIT:
        return false;      
    }
  }

  if(game_end)
    return true;

  // curssor
  if(keys[SDLK_UP]) { cursor_y--; keys[SDLK_UP] = false; }
  if(keys[SDLK_DOWN]) { cursor_y++; keys[SDLK_DOWN] = false; }
  if(keys[SDLK_LEFT]) { cursor_x--; keys[SDLK_LEFT] = false; }
  if(keys[SDLK_RIGHT]) { cursor_x++; keys[SDLK_RIGHT] = false; }

  if(cursor_y < 0) cursor_y = 0;
  if(cursor_y >= PH) cursor_y = PH-1;

  if(cursor_x < 0) cursor_x = 0;
  if(cursor_x >= PW) cursor_x = PW-1;

  if(keys[SDLK_SPACE])
  {
    keys[SDLK_SPACE] = false;

    turret *t = get_turret(cursor_x, cursor_y);

    if(t == NULL)
    {
      // Place new!

      if(money >= 10)
      {
        if(plansza[cursor_y][cursor_x] != 0)
        {
          puts("U cannot place here");
        }
        else
        {
        money -= 10;

        turrets[turret_placed].x = cursor_x;
        turrets[turret_placed].y = cursor_y;

        turrets[turret_placed].fx = (float)cursor_x + MINX + 0.30f + 0.5f;
        turrets[turret_placed].fy = (float)cursor_y + MINY + 0.33f + 0.5f;
        turrets[turret_placed].level = 1;
        turret_placed++;
        }
      }
      else
      {
        puts("Not enough money!");
      }
    }    
    else
    {
      if(money >= 8 && t->level < 3)
      {
        money -= 8;
        t->level ++;
      }
      else
      {
        puts("Not enough money!");      
      }

    }

  }


  // move enemies
  int i;
  for(i = 0; i < enemy_count; i++)
  {
    enemy *en = &enemies[i];
    if(en->hp <= 0.0f)
      continue;


    if(en->current_dest != 58)
    {


      // calc dist from target
      float dst = fabs(en->x - en->dest_x) + fabs(en->y - en->dest_y);
      if(dst < 0.05)
      {
        // select next target
        en->current_dest++;
        if(en->current_dest != 58)
        {
          float tx, ty;
          tx = (0.25f - (float)(rand() % 1001) / 2000.0f);
          ty = (0.25f - (float)(rand() % 1001) / 2000.0f);

          en->dest_x = travel_x[en->current_dest] + tx;
          en->dest_y = travel_y[en->current_dest] + ty;
        }
/*
        printf("[%i: %f, %f] changing route too %i -> %f, %f\n", 
            i,
            en->x, en->y,
            en->current_dest,
            en->dest_x,
            en->dest_y);*/
      }
      else
      {
        // move a little closer
        float tsx = (en->type == 0) ? COW_SPEED : PIG_SPEED;
        float tsy = tsx;

        tsx *= ratio;
        tsy *= ratio;

        float dstx = fabs(en->x - en->dest_x);
        float dsty = fabs(en->y - en->dest_y);

        // just one hop more
        if(dstx <= tsx) en->x = en->dest_x;
        if(dsty <= tsy) en->y = en->dest_y;

        // a little further
        if(dstx > tsx)
        {
          if(en->x < en->dest_x)
            en->x += tsx;
          else
            en->x -= tsy;
        }

        if(dsty > tsy)
        {
          if(en->y < en->dest_y)
            en->y += tsy;
          else
            en->y -= tsy;
        }
                
      }

    }
    else
    {
      if(!en->done)
      {
      life--;
      if(life == 0)
      {
        puts("PRZEGRALES!!! PRZEGRALES!!! PRZEGRALES!!! PRZEGRALES!!!");
        puts("PRZEGRALES!!! PRZEGRALES!!! PRZEGRALES!!! PRZEGRALES!!!");
        puts("PRZEGRALES!!! PRZEGRALES!!! PRZEGRALES!!! PRZEGRALES!!!");
        puts("PRZEGRALES!!! PRZEGRALES!!! PRZEGRALES!!! PRZEGRALES!!!");
        game_end = true;
      }
      en->done = true;
      }
      
    }

  }

  // add enemies
  if(last_enemy_add_time == 0)
    last_enemy_add_time = SDL_GetTicks();

  if(enemy_count < 100 && last_enemy_add_time + 500 < SDL_GetTicks())
  {
    last_enemy_add_time = SDL_GetTicks();

    // add enemy
    enemies[enemy_count].x = enemy_start_x + (0.25f - (float)(rand() % 1001) / 2000.0f);
    enemies[enemy_count].y = enemy_start_y + (0.25f - (float)(rand() % 1001) / 2000.0f);
    enemies[enemy_count].type = rand() % 2;

    if(enemies[enemy_count].type == 0)
      enemies[enemy_count].hp = 100.0f;
    else
      enemies[enemy_count].hp = 80.0f;
    
    float tx, ty;
    tx = (0.25f - (float)(rand() % 1001) / 2000.0f);
    ty = (0.25f - (float)(rand() % 1001) / 2000.0f);


    // set travel
    enemies[enemy_count].current_dest = 2;
    enemies[enemy_count].dest_x = travel_x[2] + tx;
    enemies[enemy_count].dest_y = travel_y[2] + ty;    

    //printf("%i %f %f\n", enemy_count, enemies[enemy_count].x, enemies[enemy_count].y);

    enemy_count++;
  }


  for(i = 0; i < turret_placed; i++)
  {
    turret *t = &turrets[i];

    float rng = turret_range[t->level];
    rng *= rng;

    // Any target?
    if(t->target)
    {
      // Still in range ?
      float dx = (t->fx - t->target->x);
      float dy = (t->fy - t->target->y);
      dx *= dx;
      dy *= dy;
      if(dx+dy > rng)
        t->target = NULL;
      else if(t->target->hp <= 0.0f)
        t->target = NULL;
     


    }

    // No target?
    if(t->target == NULL)
    {
      // find a target
      int j;
      for(j = 0; j < enemy_count; j++)
      {
        enemy *en = &enemies[j];
        if(!en) continue;

        if(en->hp <= 0.0f)
          continue;

        float dx = (t->fx - en->x);
        float dy = (t->fy - en->y);
        dx *= dx;
        dy *= dy;

        if(dx+dy <= rng)
        {
          t->target = en;
          break;
        }
      }
    }

    // Enemy?
    if(t->target)
    {
      if(t->last_shot + 600 - t->level*100 > SDL_GetTicks())
        continue;

      t->last_shot = SDL_GetTicks();

      t->target->hp -= turret_power[t->level] * dmg_ratio;
      if(t->target->hp <= 0.0f)
      {
        t->target->hp = 0.0f;
        puts("dead");

        money++;
      }
      
    }
    
  }

  // Done ?
  if(enemy_count == 100)
  {
    bool all_killed = true;

    for(i = 0; i < enemy_count; i++)
    {
      if(enemies[i].hp > 0.0f && enemies[i].current_dest < 58)
      {
        all_killed = false;
        break;
      }
    }

    if(all_killed)
    {
      // reset everything
      enemy_count = 0;
      life += 5; // get 5 live
      dmg_ratio /= 2.0f;
      money += 10; 

    }
  }

  
  return true;
}

// initSDL
static bool
initSDL(bool fullscreen, int width, int height)
{
  int screen_bpp;
  int screen_flag = SDL_OPENGL;
  if(fullscreen) screen_flag |= SDL_FULLSCREEN;

  screen_width = width;
  screen_height = height;
 
  const SDL_VideoInfo *info;
  SDL_Surface *surface;  

  if( SDL_Init(SDL_INIT_VIDEO | SDL_INIT_NOPARACHUTE) < 0 )
    return false;
 
  info = SDL_GetVideoInfo( );
  if(info == NULL)
    goto err;

  screen_bpp = info->vfmt->BitsPerPixel;
  SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
  SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

  surface = SDL_SetVideoMode(
            screen_width, screen_height, 
            screen_bpp, screen_flag);

  if(surface == NULL)
    goto err;

  SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY, SDL_DEFAULT_REPEAT_INTERVAL);

  return true;
  
err:
  SDL_Quit();
  return false;
}

// initOpenGL
static bool
initOpenGL()
{
  float ratio;
  ratio = (float)screen_width / (float)screen_height;
  
  glShadeModel(GL_SMOOTH);  
  glClearColor(0, 0, 0, 0);  
  glViewport(0, 0, screen_width, screen_height);  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity( );
  gluPerspective( 60.0, ratio, 1.0, 1024.0 );
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
  glDisable(GL_DEPTH_TEST); // uncomment this if going 2D
  return true;
}

unsigned int 
make_texture(const char* file_name, bool transp)
{
  // function to load texture
  GLuint texture;
  SDL_Surface *img;

  img = SDL_LoadBMP(file_name);
  if(!img)
  {
    fprintf(stderr, "File %s not found", file_name);
    return 0;
  }

  glGenTextures(1, &texture);
  glBindTexture(GL_TEXTURE_2D, texture);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

  int i, j;
  unsigned char *p = (unsigned char*)img->pixels;

  unsigned char *cpy = new unsigned char[img->h * img->w * 4];
  unsigned char *r = cpy;

  for(j = 0; j < img->h; j++)
  {
    for(i = 0; i < img->w; i++, p+=3, r+=4)
    {
      if(!p[0] && !p[1] && !p[2])
      {
        *(int*)r = 0;
      }
      else
      {
        *(int*)r = (p[0] << 16) | (p[1] << 8) | (p[2]) | 0xff000000;
      }
    }
  }

  if(img->format->BitsPerPixel == 24)
  {
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, img->w, 
	img->h, 0, GL_RGBA, GL_UNSIGNED_BYTE, cpy);
    printf("File %s is 24 bits (as 32)\n", file_name);
    //gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, img->w, 
    //       img->h, GL_RGB, GL_UNSIGNED_BYTE, img->pixels);
  }
  else if (img->format->BitsPerPixel == 32)
  {
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, img->w, 
	img->h, 0, GL_RGBA, GL_UNSIGNED_BYTE, img->pixels);

    printf("File %s is 32 bits\n", file_name);
    //gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, img->w, 
    //      img->h, GL_RGBA, GL_UNSIGNED_BYTE, img->pixels);
  }

  delete cpy;

  return texture;
}

